// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "VNEvent.hpp"
#include "scenes/LoadingScene.hpp"

namespace Dawn {
  template<class T>
  class VNSceneChangeEvent : public VNEvent {
    protected:
      void onStart() override {
        auto game = this->manager->getGame();
        LoadingScene<T> *nextScene = new LoadingScene<T>(this->manager->getGame());
        nextScene->stage();
        game->sceneCutover(nextScene);
      }
  };
}