// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/Xml.hpp"
#include "util/File.hpp"

struct LanguageString {
  std::string key;
  std::string lang;
  std::string text;
};

/**
 * Shorthand method to save a list of languages to a file.
 * 
 * @param languagesDir Directory where the language(s) are to be stored.
 * @param strings List of strings to store.
 * @return 0 for success, otherwise for failure.
 */
static int32_t languageSaveStrings(
  std::string languagesDir,
  std::vector<struct LanguageString> strings
);